@Echo off
REM Copyright (C) 2003/04 Ansgar Wiechers & Torsten Mann
REM Contact: admin@ntsvcfg.de
REM 
REM This program is free software; you can redistribute it and/or modify it under
REM the terms of the GNU General Public License as published by the Free Software Foundation;
REM either version 2 of the License, or (at your option) any later version.
REM This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
REM without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
REM See the GNU General Public License for more details.
REM
REM You should have received a copy of the GNU General Public License along with this program;
REM if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
REM MA 02111-1307, USA. 
echo.
:START
echo "svc2kXp.cmd" v2.0_build7 (09.04.2004), published under GNU GPL
echo ===============================================================

if /I "%1"=="/?" goto HELP
if /I "%1"=="/help" goto HELP
if /I "%1"=="-h" goto HELP
if /I "%1"=="--help" goto HELP
if /I "%1"=="-?" goto HELP
if /I "%1"=="--?" goto HELP
goto VERSION

:HELP
echo.
echo.                                -= Hilfe =-                           
echo Parameter:
echo /all.......Setzt ALLE Aenderungen nach www.kssysteme.de um.
echo /restore...Nimmt die letzten Aenderungen zurueck.
echo /lan.......Reaktiviert Dienste, dir fuer LAN-Betrieb benoetigt werden.
echo /s.........Standard: einige Dienste (fuer LAN-Betrieb) bleiben unveraendert.
echo.
echo Beispiel: svc2kxp.cmd /all
echo.
echo Parameters:
echo /all.......Changes all issues recommended by www.kssysteme.de ("hardening")
echo /restore...Undo last changes.
echo /lan.......Reactivates services required for LAN.
echo /s.........Standard: some services, needed for LAN-usage, keep unchanged!
echo.
echo example: svc2kxp.cmd /all
echo.
echo.
echo.
set /p CHS=[Press "G" for GNU GPL informations or q for quit]?
if /i "%CHS%"=="G" goto GNU_GPL
if /i "%CHS%"=="Q" goto QUIT_EXT
goto HELP

:GNU_GPL
CLS
ECHO Informations about GNU-General Public License for "svc2kxp.cmd"
ECHO ===============================================================
ECHO.
ECHO Copyright (C) 2003/04 Ansgar Wiechers, Torsten Mann
ECHO Contact: admin@ntsvcfg.de
ECHO. 
ECHO This program is free software; you can redistribute it and/or modify it under
ECHO the terms of the GNU General Public License as published by the Free Software
ECHO Foundation; either version 2 of the License, or (at your option) any later 
ECHO version. This program is distributed in the hope that it will be useful, but
ECHO WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
ECHO FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
ECHO details.
ECHO.
ECHO You should have received a copy of the GNU General Public License along with 
ECHO this program; if not, write to the:
ECHO.
ECHO Free Software Foundation, Inc.
ECHO 59 Temple Place, Suite 330 
ECHO Boston, MA 02111-1307, USA.
ECHO.
goto QUIT

:VERSION
REM check system version
echo Checking system version ...
ver | find /i "Windows 2000" > nul
if not errorlevel 1 goto OS2K

ver | find /i "Windows XP" > nul
if not errorlevel 1 goto OSXP

echo !!Failed!!
echo __________
echo Dieses Script ist nur unter Windows 2000 oder XP lauffaehig!
echo.
echo This script works only on Windows 2000/XP machines!
echo.
goto QUIT

:OS2K
set SYSTEM=2k
echo !Windows 2000 detected!
goto CONTINUE

:OSXP
set SYSTEM=xp
echo !Windows XP detected!

:CONTINUE
setlocal
set SELECT="no"
set SVC_BAK=%USERPROFILE%\services.reg
set DCOM_BAK=%USERPROFILE%\dcom.reg
set DCOMP_BAK=%USERPROFILE%\dcomp.reg
set SMB_BAK=%USERPROFILE%\smb.reg
set DCOM_TMP=%TEMP%\dcomoff.reg
set DCOMP_TMP=%TEMP%\dcompoff.reg
set SMB_TMP=%TEMP%\smboff.reg
if /I "%1"=="/all" (
  set SELECT="/all"
  goto SKIP_MENUE
)
if /I "%1"=="/lan" (
  set SELECT="/lan"
  goto SKIP_MENUE
)

REM checking permissions
echo Checking available permissions [local, domain] ...
net user %USERNAME% 2> nul | find /i "admin" | find /i /v "name" > nul
if errorlevel 1 (
  echo [please wait...]
  net user %USERNAME% /domain 2> nul | find /i "admin" | find /i /v "name" > nul
  if errorlevel 1 (
    echo.
    echo Failed!
    echo __________
    echo Sie verfuegen nicht ueber die erforderlichen Rechte!
    echo Melden Sie sich bitte als Administrator an.
    echo.
    echo You don't have the permissions required for this task.
    echo Please login as Administrator.
    echo.
    goto END
  )
)


REM testing for sc.exe
echo Checking for presence of SC.EXE ...
sc.exe qc > nul 2>&1
if errorlevel 1 (
  echo !!Failed!!
  echo __________
  echo Die notwendige Datei SC.EXE konnte leider nicht gefunden werden.
  echo Bitte laden Sie sich diese Datei von der unten genannten Adresse herunter:
  echo.
  echo SC.EXE couldn't be found. 
  echo Please download it from following location:
  echo.
  echo           -= ftp://ftp.microsoft.com/reskit/win2000/sc.zip =-
  echo.
  echo              NEU: Automatische Installation [BETA-Stadium]
  echo              =============================================
  echo svx2kxp.cmd kann versuchen, die notwendige Datei selbst zu installieren.
  echo Hierzu benoetigen Sie eine bestehende Internetverbindung. 
  echo.
  echo svc2kxp.cmd may try to download needed file SC.EXE if an active 
  echo internet connection exists. 
  goto SC_DOWNLOAD
)

IF /I "%1"=="/restore" goto RESTORE

:MENUE
if /I "%1"=="/s" goto SKIP_MENUE
echo.
echo                           -= Auswahl / Overview =-
echo.
echo Bitte waehlen sie einen Punkt aus, den sie ausfuehren moechten:
echo.
echo (1) Standard:   Benoetigte Dienste fuer LAN-Betrieb werden nicht veraendert.
echo (2) wie "/all": Setzt alle Vorschlaege nach kssysteme um (empfohlen!).
echo (3) wie "/lan": Reaktiviert fuer LAN-Betrieb benoetigte Dienste.
echo (4) Restore:    Nimmt die zuletzt vorgenommenen Aenderungen zurueck.
echo ______________________________________________________________________________
echo.
echo Please choose one task you want to do:
echo.
echo (1) default:     Some services, needed for LAN-usage, keep unchanged. 
echo (2) like "/all": Making all changes described under www.kssysteme.de.
echo (3) like "/lan": Reactivates necessary services used for LAN.
echo (4) restore:     Restoring last changes made.
echo.
set /p CHS=[Bitte waehlen Sie/Please choose: 1,2,3,4 or q for quit]?
if /i "%CHS%"=="1" goto SKIP_MENUE
if /i "%CHS%"=="2" (
  set SELECT="/all"
  goto SKIP_MENUE
)
if /i "%CHS%"=="3" (
  set SELECT="/lan"
  goto SKIP_MENUE
)
if /i "%CHS%"=="4" goto RESTORE
if /i "%CHS%"=="Q" goto QUIT_EXT
cls
goto START


:SKIP_MENUE
REM save registry settings
echo Saving services settings to %SVC_BAK% ...
regedit /e "%SVC_BAK%" HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services
echo Saving DCOM settings to %DCOM_BAK% ...
regedit /e "%DCOM_BAK%" HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Ole
echo Saving DCOM standard protocols settings to %DCOMP_BAK% ...
regedit /e "%DCOMP_BAK%" HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Rpc
IF /I %SELECT%=="/all" (
  echo Saving SMB settings to %SMB_BAK%
  regedit /e "%SMB_BAK%" HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\NetBT\Parameters
)
echo All done.
echo.

REM reconfigure services
REM startup: demand
echo Setting services to "demand" ...
echo Checking DHCP:
ipconfig -all | find /i "Lease" > nul
if errorlevel 1 (
  echo No active DHCP found.
  sc config DHCP start= demand
  goto skip_dhcp
)
echo DHCP active, status of service will not be changed.
:skip_dhcp
sc config dmadmin start= demand
sc config DNSCache start= demand
sc config mnmsrvc start= demand
sc config MSIServer start= demand
sc config NetDDE start= demand
sc config NetDDEdsdm start= demand
sc config Netman start= demand
sc config NTLMSsp start= demand
sc config NtmsSvc start= demand
sc config PolicyAgent start= demand
sc config RASAuto start= demand
sc config RASMan start= demand
sc config RSVP start= demand
sc config Scardsvr start= demand
sc config ScardDrv start= demand
sc config SharedAccess start= demand
sc config Sysmonlog start= demand
sc config TAPISrv start= demand
sc config TrkWks start= demand
sc config UPS start= demand
sc config W32Time start= demand
sc config WMI start= demand
IF /I %SELECT%=="/all" (
  sc config RemoteRegistry start= demand
  sc config SamSs start= demand
  sc config LmHosts start= demand
  sc config Winmgmt start= demand
)
IF /I "%SYSTEM%"=="2k" (
  sc config AppMgmt start= demand
  sc config Browser start= demand
  sc config clipsrv start= demand
  sc config EventSystem start= demand
  sc config Fax start= demand
  sc config netlogon start= demand
  sc config RPCLocator start= demand
  sc config Utilman start= demand
  IF /I %SELECT%=="/all" (
    sc config seclogon start= demand
    sc config RPCSs start= demand
    sc config lanmanServer start= demand
  )
)
IF /I "%SYSTEM%"=="xp" (
  sc config ALG start= demand
  sc config FastUserSwitchingCompatibility start= demand
  sc config helpsvc start= demand
  sc config ImapiService start= demand
  sc config Nla start= demand
  sc config RdSessMgr start= demand
  sc config seclogon start= demand
  sc config stisvc start= demand
  sc config SwPrv start= demand
  sc config TermService start= demand
  sc config upnphost start= demand
  sc config VSS start= demand
  sc config WmdmPmSp start= demand
  sc config WmiApSrv start= demand
  REM Wireless Zero Configuration - fuer WLAN-Verbindungen notwendig.
  REM Falls erforderlich auf AUTO stellen.
  REM sc config WZCSVC start= demand
)
echo.

REM startup: auto
echo Setting services to "auto" ...
sc config dmserver start= auto
sc config eventlog start= auto
sc config PlugPlay start= auto
sc config ProtectedStorage start= auto
sc config sens start= auto
sc config spooler start= auto
IF /I "%SYSTEM%"=="2k" (
  sc config lanmanworkstation start= auto
  sc config alerter start= auto
)
IF /I "%SYSTEM%"=="xp" (
  sc query InteractiveLogon | find /i "OpenService FAILED"
  if errorlevel 1 sc config InteractiveLogon start= auto
  sc config Audiosrv start= auto
  sc config CryptSvc start= auto
  sc config RPCSs start= auto
  sc config ShellHWDetection start= auto
  sc config srservice start= auto
  sc config uploadmgr start= auto
  sc config WebClient start= auto
)
echo.

REM startup: disabled
echo Setting services to "disabled" ...
sc config cisvc start= disabled
sc config MSDTC start= disabled
sc config RemoteAccess start= disabled
sc config TlntSvr start= disabled
sc config messenger start= disabled
IF /I %SELECT%=="/all" (
  sc query BITS | find /i "SERVICE_NAME"
  if not errorlevel 1 sc config BITS start= disabled
  REM ****************sc query wuauserv | find /i "SERVICE_NAME"
  REM ****************if not errorlevel 1 sc config wuauserv start= disabled
  REM ****************sc config schedule start= disabled
)
IF /I "%SYSTEM%"=="xp" (
  sc config ERSvc start= disabled
  sc config HidServ start= disabled
  sc config SSDPSRV start= disabled
)

REM stoping services they aren't needed
Echo Stopping services ...
net stop cisvc
net stop RemoteAccess
net stop TlntSvr
net stop MSDTC
net stop messenger
IF /I %SELECT%=="/all" (
  sc query BITS | find /i "SERVICE_NAME"
  if not errorlevel 1 net stop BITS
  net stop messenger
  REM **************sc query wuauserv | find /i "SERVICE_NAME"
  REM **************if not errorlevel 1 net stop wuauserv
  REM **************net stop schedule
)
echo ------------------
REM disable DCOM
echo Disabling DCOM ...
echo REGEDIT4 > "%DCOM_TMP%"
echo. >> "%DCOM_TMP%"
echo [HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Ole] >> "%DCOM_TMP%"
echo "EnableDCOM"="N" >> "%DCOM_TMP%"
echo "EnableDCOMHTTP"="N" >> "%DCOM_TMP%"
echo "EnableRemoteConnect"="N" >> "%DCOM_TMP%"
echo. >> "%DCOM_TMP%"
echo. >> "%DCOM_TMP%"
regedit /s "%DCOM_TMP%"
del /f /q "%DCOM_TMP%"

REM disable DCOM standard protocols
echo Disabling DCOM standard protocols ...
echo REGEDIT4 > "%DCOMP_TMP%"
echo. >> "%DCOMP_TMP%"
echo [HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Rpc] >> "%DCOMP_TMP%"
echo "DCOM Protocols"=hex(7):00,00,00,00 >> "%DCOMP_TMP%"
echo. >> "%DCOMP_TMP%"
echo. >> "%DCOMP_TMP%"
regedit /s "%DCOMP_TMP%"
del /f /q "%DCOMP_TMP%"
REM Disabling Port 135 and 1024
  echo Disabling port 135 and 1024 ...
  echo REGEDIT4 > "%SMB_TMP%"
  echo   - Removing RPC Client Protocols
  echo [-HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Rpc\ClientProtocols] >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo [HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Rpc\Internet] >> "%SMB_TMP%"
  echo "PortsInternetAvailable"="N" >> "%SMB_TMP%"
  echo "UseInternetPorts"="N" >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo   - Removing needless URL Handler (AIM,gopher,telnet)
  echo [-HKEY_CLASSES_ROOT\AIM] >> "%SMB_TMP%"
  echo [-HKEY_CLASSES_ROOT\gopher] >> "%SMB_TMP%"
  echo [-HKEY_CLASSES_ROOT\telnet] >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  regedit /s "%SMB_TMP%"
  del /f /q "%SMB_TMP%"

IF /I %SELECT%=="/all" (
  REM disable SMB port 445
  echo Disabling SMB port 445 ...
  echo REGEDIT4 > "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\NetBT\Parameters] >> "%SMB_TMP%"
  echo "SMBDeviceEnabled"=dword:00000000 >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  regedit /s "%SMB_TMP%"
  del /f /q "%SMB_TMP%"
  set REBOOT_REQUIRED=yes
)

REM Skip Billboard because /all is used
if /I %SELECT%=="/all" goto sw_all
echo ___________________________________________________________________
echo                  *** Zusammenfassung / Result ***
echo.
echo Es wurden NICHT alle Aenderungen umgesetzt!
echo Um alle Vorschlaege von kssysteme.de umzusetzen, verwenden Sie
echo bitte den Parameter '/all' oder waehlen Sie im Menue den Punkt "2".
echo.
echo Not all operations could be performed. To change all issues listed 
echo on www.kssysteme.de please use parameter '/all' or select item "2"!
echo ___________________________________________________________________

:sw_all

IF /I %SELECT%=="/lan" (
  REM re-enable services for LANs
  REM startup: auto
  echo Re-enabling services ...
  sc config LmHosts  start= auto
  REM sc config messenger start= auto
  sc config RemoteRegistry start= auto
  sc config SamSs start= auto
  REM sc config schedule  start= auto
  sc config Winmgmt start= auto
  IF /I "%SYSTEM%"=="2k" (
    sc config RPCSs start= auto
    sc config lanmanServer start= auto
    sc config seclogon start= auto
  )

  REM start re-enabled services
  echo Starting services ...
  REM net start messenger
  net start RemoteRegistry
  net start SamSs
  REM net start schedule
  net start LmHosts
  net start Winmgmt
  IF /I "%SYSTEM%"=="2k" (
    net start lanmanServer
    net start RPCSs
    net start seclogon
  )

  REM enable SMB port 445
  echo Enabling SMB port 445 ...
  echo REGEDIT4 > "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\NetBT\Parameters] >> "%SMB_TMP%"
  echo "SMBDeviceEnabled"=dword:00000001 >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  echo. >> "%SMB_TMP%"
  regedit /s "%SMB_TMP%"
  del /f /q "%SMB_TMP%"
  set REBOOT_REQUIRED=yes
)

echo.

goto END

:RESTORE
echo ____________________________________________________
echo Letzte Aenderungen rueckgaengig machen [y/n]?
set /p UNDO=Undo last changes [y/n]?
if /i "%UNDO%"=="y" (
  echo _______________________________________________________________
  echo Hinweis:
  echo ========
  echo Moeglicherweise meldet Windows Fehler beim Importieren.
  echo Ignorieren Sie diese mit Klick auf "OK".
  echo.
  echo Windows will probably report an error during importing the
  echo backups. Just ignore this by clicking the "OK" button!
  echo _______________________________________________________________
  echo Status:
  echo -------
  if exist "%SVC_BAK%" (
    echo Importing services ["%SVC_BAK%"]...
    regedit /s "%SVC_BAK%"
    set action=""
  )

  if exist "%DCOM_BAK%" (
    echo Importing DCOM ["%DCOM_BAK%"]...    
    regedit /s "%DCOM_BAK%"
  )

  if exist "%DCOMP_BAK%" (
    echo Importing DCOM-standard protocols ["%DCOMP_BAK%"]...
    regedit /s "%DCOMP_BAK%"
  )
  if exist "%SMB_BAK%" (
    echo Importing SMB-settings ["%SMB_BAK%"]...
    regedit /s "%SMB_BAK%"
  )
  echo _______________________________________________________________
  echo             *** Zusammenfassung / Result ***
  echo.
  echo Die Ruecksicherung wurde ausgefuehrt. Wenn in der oberen Zeile 
  echo keine Statusmeldungen zu sehen sind, existierten keine rueckzu-
  echo sichernden Dateien.
  echo Bitte starten Sie anschliessend Ihren Rechner neu.
  echo.
  echo Restore finished. If you don't see any messages in the status
  echo box, there where no files to restore. Please reboot.
  echo _______________________________________________________________  

)
goto END

:SC_DOWNLOAD
echo ______________________________________________________________
echo Besteht eine aktive Internetverbindung?
echo Are you connected to the internet?
echo.
set /p UNDO=Bitte waehlen/Please choose: [y/n]?
  if /i "%UNDO%"=="y" goto SC_DOWNLOAD_OK
goto END

:SC_DOWNLOAD_OK
if exist "%SYSTEMROOT%"\sc.zip goto SCE
echo Generating FTP-script ...
if exist "%USERPROFILE%"\script_sc.ls del /F "%USERPROFILE%"\script_sc.ls
echo open 207.46.133.140 >"%USERPROFILE%"\script_sc.ls
echo user anonymous anonymous@aol.com >>"%USERPROFILE%"\script_sc.ls
echo type binary >>"%USERPROFILE%"\script_sc.ls
echo user anonymous anonymous@aol.com >>"%USERPROFILE%"\script_sc.ls
echo type binary >>"%USERPROFILE%"\script_sc.ls
echo get /reskit/win2000/sc.zip %SYSTEMROOT%\SC.ZIP >>"%USERPROFILE%"\script_sc.ls
echo quit >>"%USERPROFILE%"\script_sc.ls

echo Downloading SC.EXE ...
ftp -s:"%USERPROFILE%"\script_sc.ls
del /F "%USERPROFILE%"\script_sc.ls

:SCE
if exist "%SYSTEMROOT%"\pkunzip.exe goto PKE
echo Generating FTP-script ...
if exist "%USERPROFILE%"\script_pk.ls del /F "%USERPROFILE%"\script_pk.ls
echo open ftp.uni-duesseldorf.de >"%USERPROFILE%"\script_pk.ls
echo user anonymous anonymous@aol.com >>"%USERPROFILE%"\script_pk.ls
echo type binary >>"%USERPROFILE%"\script_pk.ls
echo user anonymous anonymous@aol.com >>"%USERPROFILE%"\script_pk.ls
echo type binary >>"%USERPROFILE%"\script_pk.ls
echo get /pub/msdos/archiver/pkunzip.exe %SYSTEMROOT%\pkunzip.exe >>"%USERPROFILE%"\script_pk.ls
echo quit >>"%USERPROFILE%"\script_pk.ls
echo Downloading PKUNZIP.EXE ...
ftp -s:"%USERPROFILE%"\script_pk.ls
del /F "%USERPROFILE%"\script_pk.ls

:PKE
if not exist "%SYSTEMROOT%"\sc.zip (
  echo.
  echo Download fehlgeschlagen. Bitte laden sie sich die Datei SC.ZIP manuell
  echo herunter und kopieren diese nach %SYSTEMROOT%\.
  echo.
  echo Downloading SC.ZIP fails. Please download it manually an copy it to
  echo %SYSTEMROOT%\.
)
if not exist "%SYSTEMROOT%"\pkunzip.exe (
  echo.
  echo Die Datei PKUNZIP.EXE konnte nicht gefunden werden. Diese wird zum 
  echo Entpacken des Archivs SC.ZIP benoetigt!
  echo.
  echo File PKUNZIP.EXE not found. File needed to decompress archive SC.EXE:
)

if exist "%SYSTEMROOT%"\SC.ZIP (
  if exist "%SYSTEMROOT%"\pkunzip.exe (
    %SYSTEMROOT%\pkunzip.exe -e "%SYSTEMROOT%"\sc.zip sc.exe
  )
)
move /y sc.exe "%SYSTEMROOT%"\
REM del /F "%SYSTEMROOT%"\SC.ZIP
REM del /F "%SYSTEMROOT%"\PKUNZIP.EXE
echo.
echo Skript wird neu gestartet...
echo Running script again...
goto START


:END
IF "%REBOOT_REQUIRED%"=="yes" (
  echo ______________________________________________________
  echo          *** Zusammenfassung / Result ***
  echo.
  echo Es wurden alle gewuenschten Aenderungen durchgefuehrt.
  IF /I %SELECT%=="/lan" echo Notwendige LAN-Einstellungen wurden aktiviert.
  echo Bitte starten Sie anschliessend Ihren Rechner neu.
  echo.
  echo Changes successfully applied. Please reboot.
  echo ______________________________________________________  
)

endlocal

:QUIT
echo ______________________________________________________
echo [Taste zum Beenden druecken]   [Press any key to quit] 
echo ------------------------------------------------------
pause>NUL
:QUIT_EXT
